#include "time.h"
#include "stm32f10x.h"
#include "stm32f10x_gpio.h"


static void GENERAL_TIM_GPIO_Config(void) 
{
  GPIO_InitTypeDef GPIO_InitStructure;
	// Ƚͨ3 GPIO ʼ
	RCC_APB2PeriphClockCmd(GENERAL_TIM_CH3_GPIO_CLK, ENABLE);
  GPIO_InitStructure.GPIO_Pin =  GENERAL_TIM_CH3_PIN;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GENERAL_TIM_CH3_PORT, &GPIO_InitStructure);
	
	// Ƚͨ4 GPIO ʼ
	RCC_APB2PeriphClockCmd(GENERAL_TIM_CH4_GPIO_CLK, ENABLE);
  GPIO_InitStructure.GPIO_Pin =  GENERAL_TIM_CH4_PIN;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GENERAL_TIM_CH4_PORT, &GPIO_InitStructure);

}

///*
// * ע⣺TIM_TimeBaseInitTypeDefṹ5ԱTIM6TIM7ļĴֻ
// * TIM_PrescalerTIM_PeriodʹTIM6TIM7ʱֻʼԱɣ
// * Աͨöʱ͸߼ʱ.
// *-----------------------------------------------------------------------------
// *typedef struct
// *{ TIM_Prescaler            
// *	TIM_CounterMode			     TIMx,x[6,7]ûУ
// *  TIM_Period               
// *  TIM_ClockDivision        TIMx,x[6,7]ûУ
// *  TIM_RepetitionCounter    TIMx,x[1,8,15,16,17]
// *}TIM_TimeBaseInitTypeDef; 
// *-----------------------------------------------------------------------------
// */

/* ----------------   PWMź ںռձȵļ--------------- */
// ARR ԶװؼĴֵ
// CLK_cntʱӣ Fck_int / (psc+1) = 72M/(psc+1)
// PWM źŵ T = ARR * (1/CLK_cnt) = ARR*(PSC+1) / 72M
// ռձP=CCR/(ARR+1)

static void GENERAL_TIM_Mode_Config(void)
{
	
		uint16_t CCR3_Val = 7;
		uint16_t CCR4_Val = 8;
		TIM_OCInitTypeDef  TIM_OCInitStructure;//ʱģʽṹ
	
	  TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;//ʱṹ
  // ʱʱ,ڲʱCK_INT=72M
	GENERAL_TIM_APBxClock_FUN(GENERAL_TIM_CLK,ENABLE);

/*--------------------ʱṹʼ-------------------------*/
	// ڣΪ100K
	

	// ԶװؼĴֵۼTIM_Period+1Ƶʺһ»ж
	TIM_TimeBaseStructure.TIM_Period=GENERAL_TIM_Period;	
	// CNTʱ = Fck_int/(psc+1)
	TIM_TimeBaseStructure.TIM_Prescaler= GENERAL_TIM_Prescaler;	
	// ʱӷƵ ʱʱҪõ
	TIM_TimeBaseStructure.TIM_ClockDivision=TIM_CKD_DIV1;		
	// ģʽΪϼ
	TIM_TimeBaseStructure.TIM_CounterMode=TIM_CounterMode_Up;		
	// ظֵûõù
	TIM_TimeBaseStructure.TIM_RepetitionCounter=0;	
	// ʼʱ
	TIM_TimeBaseInit(GENERAL_TIM, &TIM_TimeBaseStructure);

	/*--------------------ȽϽṹʼ-------------------*/	

	// ΪPWMģʽ1
	TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;
	// ʹ
	TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
	// ͨƽ	
	TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;
	
	// Ƚͨ 3
	TIM_OCInitStructure.TIM_Pulse = CCR3_Val;
	TIM_OC3Init(GENERAL_TIM, &TIM_OCInitStructure);
	TIM_OC3PreloadConfig(GENERAL_TIM, TIM_OCPreload_Enable);
	
	// Ƚͨ 4
	TIM_OCInitStructure.TIM_Pulse = CCR4_Val;
	TIM_OC4Init(GENERAL_TIM, &TIM_OCInitStructure);
	TIM_OC4PreloadConfig(GENERAL_TIM, TIM_OCPreload_Enable);
	
	// ʹܼ
	TIM_Cmd(GENERAL_TIM, ENABLE);
	//ʹ  ͨöʱҪһ
	TIM_CtrlPWMOutputs(TIM8, ENABLE);
}

void GENERAL_TIM_Init(void)
{
	GENERAL_TIM_GPIO_Config();
	GENERAL_TIM_Mode_Config();		
}
