#include "rtc.h"    

void RTC_Set(unsigned int syear,unsigned char smon,unsigned char sday,unsigned char hour,unsigned char min,unsigned char sec);
 /**********************718ʵҿ*********************
*  :RTC_NVIC_Config
*  :          
*  :rtcжϷ
*  ʹʾ:
*******************************************************************/
static void RTC_NVIC_Config(void)
{	
  NVIC_InitTypeDef NVIC_InitStructure;
	NVIC_InitStructure.NVIC_IRQChannel = RTC_IRQn;		//RTCȫж
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;	//ռȼ1λ,ȼ3λ
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;	//ռȼ0λ,ȼ4λ
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;		//ʹܸͨж
	NVIC_Init(&NVIC_InitStructure);		//NVIC_InitStructָĲʼNVICĴ
}
 /**********************718ʵҿ*********************
*  :RTC_Init
*  :          
*  :rtcʼ
*  ʹʾ:
*******************************************************************/

void RTCInit(void)
{
	//ǲǵһʱ
	u8 temp=0;
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR | RCC_APB1Periph_BKP, ENABLE);	//ʹPWRBKPʱ   
	PWR_BackupAccessCmd(ENABLE);	//ʹܺ󱸼Ĵ  
	if (BKP_ReadBackupRegister(BKP_DR1) != 0x5050)		//ָĺ󱸼Ĵж:дָݲ
		{	 			 
		BKP_DeInit();	//λ 	
		RCC_LSEConfig(RCC_LSE_ON);	//ⲿپ(LSE),ʹپ
		while (RCC_GetFlagStatus(RCC_FLAG_LSERDY) == RESET&&temp<250)	//ָRCC־λ,ȴپ
			{
			temp++;
			}
		if(temp>=250); 
		RCC_RTCCLKConfig(RCC_RTCCLKSource_LSE);		//RTCʱ(RTCCLK),ѡLSEΪRTCʱ    
		RCC_RTCCLKCmd(ENABLE);	//ʹRTCʱ  
		RTC_WaitForLastTask();	//ȴһζRTCĴд
		RTC_WaitForSynchro();		//ȴRTCĴͬ  
		RTC_ITConfig(RTC_IT_SEC, ENABLE);		//ʹRTCж
		RTC_WaitForLastTask();	//ȴһζRTCĴд
		RTC_EnterConfigMode();/// 	
		RTC_SetPrescaler(32767); //RTCԤƵֵ
		RTC_WaitForLastTask();	//ȴһζRTCĴд
		RTC_Set(2015,1,14,17,00,55);  //ʱ	
		RTC_ExitConfigMode(); //˳ģʽ  
		BKP_WriteBackupRegister(BKP_DR1, 0X5050);	//ָĺ󱸼Ĵдû
		}
	else//ϵͳʱ
		{

		RTC_WaitForSynchro();	//ȴһζRTCĴд
		RTC_ITConfig(RTC_IT_SEC, ENABLE);	//ʹRTCж
		RTC_WaitForLastTask();	//ȴһζRTCĴд
		}
	RTC_NVIC_Config();//RCTжϷ		    				     
	RTC_Get();//ʱ	

}


 /**********************718ʵҿ*********************
*  : Is_Leap_Year
*  :    year      
*  :жǲ
*	 ʹʾ:Is_Leap_Year2010;
*******************************************************************/

u8 Is_Leap_Year(u16 year)
{			  
	if(year%4==0) //ܱ4
	{ 
		if(year%100==0) 
		{ 
			if(year%400==0)return 1;//00β,Ҫܱ400 	   
			else return 0;   
		}else return 1;   
	}else return 0;	
}	 			   

 /**********************718ʵҿ*********************1970~2099ΪϷ
*  : RTC_Set
*  :   syear,smon,sday,hour,min,sec       
*  :	sʱ
*	 ʹʾ:RTC_Set2010,2,20,11,2,1;
*******************************************************************/		

u8 const table_week[12]={0,3,3,6,1,4,6,2,5,0,3,5}; //ݱ	  
//ƽ·ڱ
const u8 mon_table[12]={31,28,31,30,31,30,31,31,30,31,30,31};
void RTC_Set(unsigned int syear,unsigned char smon,unsigned char sday,unsigned char hour,unsigned char min,unsigned char sec)
{
	u16 t;
	u32 seccount=0;   
	for(t=1970;t<syear;t++)							//ݵ
	{
		if(Is_Leap_Year(t))seccount+=31622400;//
		else seccount+=31536000;			  //ƽ
	}
	smon-=1;
	for(t=0;t<smon;t++)	   //ǰ·ݵ
	{
		seccount+=(u32)mon_table[t]*86400;//·
		if(Is_Leap_Year(syear)&&t==1)seccount+=86400;//2·һ	   
	}
	seccount+=(u32)(sday-1)*86400;//ǰڵ 
	seccount+=(u32)hour*3600;//Сʱ
    seccount+=(u32)min*60;	 //
	seccount+=sec;//Ӽȥ

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR | RCC_APB1Periph_BKP, ENABLE);	//ʹPWRBKPʱ  
	PWR_BackupAccessCmd(ENABLE);	//ʹRTCͺ󱸼Ĵ 
	RTC_SetCounter(seccount);	//RTCֵ

	RTC_WaitForLastTask();	//ȴһζRTCĴд  		    
}

 /**********************718ʵҿ*********************
*  :RTC_Alarm_Set
*  :     syear,smon,sday,hour,min,sec      
*  :  ʼʱ
*	 ʹʾ:RTC_Alarm_Set2010,2,20,11,2,1;
*******************************************************************/

u8 RTC_Alarm_Set(u16 syear,u8 smon,u8 sday,u8 hour,u8 min,u8 sec)
{
	u16 t;
	u32 seccount=0;
	if(syear<1970||syear>2099)return 1;	   
	for(t=1970;t<syear;t++)	//ݵ
	{
		if(Is_Leap_Year(t))seccount+=31622400;//
		else seccount+=31536000;			  //ƽ
	}
	smon-=1;
	for(t=0;t<smon;t++)	   //ǰ·ݵ
	{
		seccount+=(u32)mon_table[t]*86400;//·
		if(Is_Leap_Year(syear)&&t==1)seccount+=86400;//2·һ	   
	}
	seccount+=(u32)(sday-1)*86400;//ǰڵ 
	seccount+=(u32)hour*3600;//Сʱ
    seccount+=(u32)min*60;	 //
	seccount+=sec;//Ӽȥ 			    
	//ʱ
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR | RCC_APB1Periph_BKP, ENABLE);	//ʹPWRBKPʱ   
	PWR_BackupAccessCmd(ENABLE);	//ʹܺ󱸼Ĵ  
	//Ǳ!
	
	RTC_SetAlarm(seccount);
 
	RTC_WaitForLastTask();	//ȴһζRTCĴд  	
	
	return 0;	    
}

 /**********************718ʵҿ*********************
*  :RTC_Get
*  :          
*  :ȡʱ
*	ʹʾ:
*******************************************************************/

RTCDate RTC_Get(void)
{
	RTCDate calendar;
	static u16 daycnt=0;
	u32 timecount=0; 
	u32 temp=0;
	u16 temp1=0;	  
    timecount=RTC_GetCounter();	 
 	temp=timecount/86400;   //õ(Ӧ)
	if(daycnt!=temp)//һ
	{	  
		daycnt=temp;
		temp1=1970;	//1970꿪ʼ
		while(temp>=365)
		{				 
			if(Is_Leap_Year(temp1))//
			{
				if(temp>=366)temp-=366;//
				else {temp1++;break;}  
			}
			else temp-=365;	  //ƽ 
			temp1++;  
		}   
		calendar.w_year=temp1;//õ
		temp1=0;
		while(temp>=28)//һ
		{
			if(Is_Leap_Year(calendar.w_year)&&temp1==1)//ǲ/2·
			{
				if(temp>=29)temp-=29;//
				else break; 
			}
			else 
			{
				if(temp>=mon_table[temp1])temp-=mon_table[temp1];//ƽ
				else break;
			}
			temp1++;  
		}
		calendar.w_month=temp1+1;	//õ·
		calendar.w_date=temp+1;  	//õ 
	}
	temp=timecount%86400;     		//õ   	   
	calendar.hour=temp/3600;     	//Сʱ
	calendar.min=(temp%3600)/60; 	//	
	calendar.sec=(temp%3600)%60; 	//
	
	return calendar;
}	 
 /**********************718ʵҿ*********************
*  : RTC_Get_Week
*  :    yearmonthday      
*  :ڻõǰڼ
*	 ʹʾ:RTC_Get_Week2010,2,25;
*******************************************************************/														 
u8 RTC_Get_Week(u16 year,u8 month,u8 day)
{	
	u16 temp2;
	u8 yearH,yearL;
	
	yearH=year/100;	yearL=year%100; 
	// Ϊ21,100  
	if (yearH>19)yearL+=100;
	// ֻ1900֮  
	temp2=yearL+yearL/4;
	temp2=temp2%7; 
	temp2=temp2+day+table_week[month-1];
	if (yearL%4==0&&month<3)temp2--;
	return(temp2%7);
}			  
















