#include "stm32f10x.h"
#include "iic.h"


/************************************************************
*ģIICųʼ
*ʼIICõĸIO
************************************************************/
void IIC_GPIO_Configuration( GPIO_TypeDef * GPIOx_SDA , uint16_t SDA_Pin , GPIO_TypeDef * GPIOx_SCL , uint16_t SCL_Pin )
{
	GPIO_InitTypeDef GPIO_InitStructure;															//GPIOýṹ
	uint32_t RCC_GPIOx_SDA = 0;																				
	uint32_t RCC_GPIOx_SCL = 0;

	//õ˲Ŷ˿
	RCC_GPIOx_SDA = GPIO_Filter( GPIOx_SDA );													
	RCC_GPIOx_SCL = GPIO_Filter( GPIOx_SCL );
	
	//ʹʱ
  RCC_APB2PeriphClockCmd(RCC_GPIOx_SDA,ENABLE);
	RCC_APB2PeriphClockCmd(RCC_GPIOx_SCL,ENABLE);

	//
	GPIO_InitStructure.GPIO_Pin = SDA_Pin;
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
	GPIO_Init(GPIOx_SDA, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = SCL_Pin;
	GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_Out_OD;
	GPIO_Init(GPIOx_SCL, &GPIO_InitStructure);

	//ʼICCģʽ
	SET_SDA;
	SET_SCL;  
}


/************************************************************/
//IICʱ
/************************************************************/
void IIC_Delay(void)
{
	u32 i = 5;
	while( i-- );
}

/*******************************************************************
TWI_START

*******************************************************************/
u8 IIC_Start(void)
{
	SET_SDA;
	IIC_DELAY;

	SET_SCL;
	IIC_DELAY;

	if( IIC_SDA_STATE == RESET )
	{
		return IIC_BUS_BUSY;
	}

	RESET_SDA;
	IIC_DELAY;

	RESET_SCL;
	IIC_DELAY;

	if( IIC_SDA_STATE == SET )
	{
		return IIC_BUS_ERROR;
	}

	return IIC_BUS_READY;
}

/*******************************************************************
TWI_STOP
ֹͣ
*******************************************************************/
void IIC_Stop(void)
{
	RESET_SDA;
	IIC_DELAY;

	SET_SCL;
	IIC_DELAY;

	SET_SDA;
	IIC_DELAY;
}

/*******************************************************************************
* :IIC_SendNACK                                                                     
*     :յ,NACK                                                                                                                                       
 *******************************************************************************/
void IIC_SendNACK(void)
{
	RESET_SDA;
	IIC_DELAY;
	SET_SCL;
	IIC_DELAY;
	RESET_SCL; 
	IIC_DELAY; 
}

/*******************************************************************************
* :IIC_SendACK                                                                     
*     :յ,ACK                                                                                                                                        
*******************************************************************************/
void IIC_SendACK(void)
{
	SET_SDA;
	IIC_DELAY;
	SET_SCL;
	IIC_DELAY;
	RESET_SCL; 
	IIC_DELAY;
}

/*******************************************************************************
 * :IIC_SendByte                                                                     
 *     :һֽ                                                                                                                                      
 *******************************************************************************/
u8 IIC_SendByte(u8 Data)
{
	 u8 i;
	 RESET_SCL;
	 for(i=0;i<8;i++)
	 {  
		//---------ݽ----------
		if(Data&0x80)
		{
			SET_SDA;
		}
		else
		{
			RESET_SDA;
		} 
		Data<<=1;
		IIC_DELAY;
		//---ݽһʱ----
		//----һ[] 
		SET_SCL;
		IIC_DELAY;
		RESET_SCL;
		IIC_DELAY;//ʱ,ֹSCLûɵʱıSDA,ӶSTART/STOPź
		//---------------------------   
	 }
	 //մӻӦ 
	 SET_SDA; 
	 IIC_DELAY;
	 SET_SCL;
	 IIC_DELAY;   
	 if(IIC_SDA_STATE)
	 {
		RESET_SCL;
		return IIC_NACK;
	 }
	 else
	 {
		RESET_SCL;
		return IIC_ACK;  
	 }    
}

/*******************************************************************************
 * :IIC_ReceiveByte                                                                     
 *     :һֽ                                                                                                                                       
 *******************************************************************************/
u8 IIC_RecvByte(void)
{
	 u8 i,Dat = 0;
	 SET_SDA;
	 RESET_SCL; 
	 Dat=0;
	 for(i=0;i<8;i++)
	 {
		SET_SCL;//ʱ[],ôӻ׼ 
		IIC_DELAY; 
		Dat<<=1;
		if(IIC_SDA_STATE) //״̬
		{
			Dat|=0x01; 
		}   
		RESET_SCL;//׼ٴν  
		IIC_DELAY;//ȴ׼         
	 }
	 return Dat;
}

/************************************************
*:Single_Write_IIC
*:SlaveAddressӻַREG_AddressĴַREG_data
*:ֽд
*************************************************/

void Single_Write_IIC(u8 SlaveAddress,u8 REG_Address,u8 REG_data)
{
    IIC_Start();                  //ʼź
    IIC_SendByte(SlaveAddress);   //豸ַ+дź
    IIC_SendByte(REG_Address);    //ڲĴַ //οpdf22ҳ 
    IIC_SendByte(REG_data);       //ڲĴݣ //οpdf22ҳ 
    IIC_Stop();                   //ֹͣź
}

/************************************************
*:Single_Read_IIC
*:SlaveAddressӻַREG_AddressĴַREG_data
*:ֽڶȡ
*************************************************/
u8 Single_Read_IIC(u8 SlaveAddress, u8 REG_Address)
{  
	u8 REG_data;
    IIC_Start();                          //ʼź
    IIC_SendByte(SlaveAddress);           //豸ַ+дź
    IIC_SendByte(REG_Address);            //ʹ洢Ԫַ//0ʼ	
    IIC_Start();                          //ʼź
    IIC_SendByte(SlaveAddress+1);         //豸ַ+ź
    REG_data = IIC_RecvByte();              //Ĵ
	IIC_SendACK();   
	IIC_Stop();                           //ֹͣź
    return REG_data; 
}


/************************************************
*:GPIO_Filter
*:GPIOַ
*:ѡʼʱ
*************************************************/
uint16_t GPIO_Filter( GPIO_TypeDef * GPIOx )
{	 
	uint32_t RCC_GPIOx = 0; 

	if( GPIOx == GPIOA )
	{
		RCC_GPIOx = RCC_APB2Periph_GPIOA;
	}
	else if( GPIOx == GPIOA )
	{
		RCC_GPIOx = RCC_APB2Periph_GPIOA;
	}
	else if( GPIOx == GPIOB )
	{
		RCC_GPIOx = RCC_APB2Periph_GPIOB;
	}
	else if( GPIOx == GPIOC )
	{
		RCC_GPIOx = RCC_APB2Periph_GPIOC;
	}
	else if( GPIOx == GPIOD )
	{
		RCC_GPIOx = RCC_APB2Periph_GPIOD;
	}
	else if( GPIOx == GPIOE )
	{
		RCC_GPIOx = RCC_APB2Periph_GPIOE;
	}
	else if( GPIOx == GPIOF )
	{
		RCC_GPIOx = RCC_APB2Periph_GPIOF;
	}
	else if( GPIOx == GPIOG )
	{
		RCC_GPIOx = RCC_APB2Periph_GPIOG;
	}
	return RCC_GPIOx;
}

